/*
# positions
#  main=(100,100)
*/
types
  States = {opening, closing, open, closed}

interactor main
 attributes
  [vis] status: States
 actions
  # Remote control button
  [vis] rcButton
  # Gate open sensor
  oSensor
  # Gate closed sensor
  cSensor
 axioms
  [] status = closed
  status = closed -> [rcButton] (status' = opening)
  status = opening -> [rcButton] (status' = closing)
  status = closing -> [rcButton] (status' = opening)
  [cSensor] (status' = closed)
  [oSensor] (status' = open)
  per(oSensor) -> status = opening
  per(cSensor) -> status = closing
  status = open -> [rcButton] (status' = closing)
 test
  AG!(status=opening) #Verified False
 test
  AG!(( status=opening & status=closing)) #Verified True
 test
  AG!(oSensor & status=open) #Verified False
 test
  AG(status=opening -> AF(status=open | rcButton)) #Verified False
